您的位置:首页 > 大数据 > 人工智能

【贪心】【2014 Multi-University Training Contest 2】1011 ZCC Loves Codefires

2014-08-08 11:06 501 查看
ZCC Loves Codefires

Problem Description

Though ZCC has many Fans, ZCC himself is a crazy Fan of a coder, called "Memset137".
It was on Codefires(CF), an online competitive programming site, that ZCC knew Memset137, and immediately became his fan.
But why?
Because Memset137 can solve all problem in rounds, without unsuccessful submissions; his estimation of time to solve certain problem is so accurate, that he can surely get an Accepted the second he has predicted. He soon became
IGM, the best title of Codefires. Besides, he is famous for his coding speed and the achievement in the field of Data Structures.
After become IGM, Memset137 has a new goal: He wants his score in CF rounds to be as large as possible.
What is score? In Codefires, every problem has 2 attributes, let's call them Ki and Bi(Ki, Bi>0). if Memset137 solves the problem at Ti-th second, he gained Bi-Ki*Ti score. It's guaranteed Bi-Ki*Ti is always positive during the
round time.
Now that Memset137 can solve every problem, in this problem, Bi is of no concern. Please write a program to calculate the minimal score he will lose.(that is, the sum of Ki*Ti).
 

Input
The first line contains an integer N(1≤N≤10^5), the number of problem in the round.
The second line contains N integers Ei(1≤Ei≤10^4), the time(second) to solve the i-th problem.
The last line contains N integers Ki(1≤Ki≤10^4), as was described.
 

Output
One integer L, the minimal score he will lose.
 

Sample Input
3
10 10 20
1 2 3
 

Sample Output
150

Hint
Memset137 takes the first 10 seconds to solve problem B, then solves problem C at the end of the 30th second. Memset137 gets AK at the end of the 40th second.
L = 10 * 2 + (10+20) * 3 + (10+20+10) * 1 = 150. 

 题目大意:有一个大神每道题都能在预计的时间内做出来,这个比赛的计分类似于CF,作出每道题时,会在满分上损失Ki*Ti的分数,问怎样安排做题顺序使得损失的分数最小

思路:一看到这个题,第一感觉是DP,但是仔细想了一下发现DP不太能做,然后就开始YY。最后的方法是一个贪心,策略是用Ei/Ki作为每道题的权重,按权重排序,排序之后其实就是做题顺序了。

可惜的是hdu的longlong输出要用I64d,我开始用了lld,白WA了一次。确实是深刻理解了学长的那句话:能用cin、cout就用,不能用再去用标准输入输出。

#include <iostream>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include<algorithm>
using namespace std;

struct p{
int e,k;
double b;
}a[100000+50];
int n;

int cmp(p p1,p p2){
return p1.b<p2.b;
}

int main(){
while (scanf("%d",&n)!=EOF){
for (int i=0;i<n;i++){
//scanf("%d",&a[i].e);
cin>>a[i].e;
}
for (int i=0;i<n;i++){
//scanf("%d",&a[i].k);
cin>>a[i].k;
a[i].b=((double)a[i].e/(double)a[i].k);
}

sort(a,a+n,cmp);

long long ans=0,time=0;
for (int i=0;i<n;i++){
time+=a[i].e;
ans+=time*a[i].k;
}

//printf("%lld\n",ans);
cout<<ans<<endl;
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  多校
相关文章推荐